#include <stdio.h>
#include <errno.h>
#include <termios.h>


#define TIOCSETMODE	0x5425
#define TIOCINITEDIT	0x5426


char buf[4096];


main(int argc, char **argv) {
	int ldisc;
	int fd;
	struct termios termios;
	char *bufp;

	if (argc == 1) {
		bufp = NULL;
	} else if (argc == 2) {
		ldisc = 8;
		if ((fd = open(argv[1], 0)) < 0) {
			fprintf(stderr, "ttymode: cannot open %s\n", argv[1]);
			exit(2);
		}
		if (read(fd, buf, sizeof buf) <= 0) {
			fprintf(stderr, "ttymode: cannot read %s\n", argv[1]);
			exit(2);
		}
		bufp = buf;

		/* be sure that the termios modes are reasonable */
		if (ioctl(0, TCGETS, &termios) < 0) {
			perror("TCGETS");
			exit(2);
		}
		termios.c_line = 8;
		termios.c_lflag |= IEXTEN;
		if (ioctl(0, TCSETS, &termios) < 0) {
			perror("TCSETS");
			exit(2);
		}
	}
	if (ioctl(0, TIOCINITEDIT, bufp) < 0) {
		perror("TIOCINITEDIT");
		exit(2);
	}
	return 0;
}
